#include "micro.h"

#define P1_P2_BUFFER_SIZE 12
#define GAP 6

#define SER_PORT_FOR_READ SER_P2
#define SER_PORT_FOR_WRITE SER_P1

static int P1_P2_BUF_pos;
static int read_pos;
static int P1blocked;


static int P1_P2_buffer[P1_P2_BUFFER_SIZE];

static int ly, ry;

/*   Wait()    */
void Wait(unsigned long long x)
{
	unsigned long long mcc;
	for(mcc = 0; mcc < x*1000000; mcc++) ;
}

void Print_Out_Data(int n)
{
	bSetCursor(40,ly++);
	bSetColor(SCR_White, SCR_Black, 1);
	bPrintInteger(n);
	bSetColor(SCR_White, SCR_Black, 0);
	bNewLine();
	if(ry == 21)
	{
		bScrollWindow(2,0,21,39,1);
		ry--;
    }
}


void Print_In_Data(int n)
{
	bSetCursor(0,ly++);
	bSetColor(SCR_White, SCR_Black, 1);
	bPrintInteger(n);
	bSetColor(SCR_White, SCR_Black, 0);
	bNewLine();
	if(ly == 21)
	{
		bScrollWindow(2,0,21,39,1);
		ly--;
    }
}

/* ================================================================================ */
/* ======================        ================ */
/* ================================================================================ */

void ReadFromSerial()
{
	char buffer[2];


	/*    GAP  */

	for (P1_P2_BUF_pos=0;P1_P2_BUF_pos<GAP;P1_P2_BUF_pos++)
	{
		/*   bytes     */
		buffer[0] = QSR_ReadChar(SER_PORT_FOR_READ);
		buffer[1] = QSR_ReadChar(SER_PORT_FOR_READ);

		/*      */
		P1_P2_buffer[P1_P2_BUF_pos]=*((int *)buffer);
        Print_In_Data(*((int*)buffer));
	}

	V(2);

	while(1)
	{
		/*   bytes     */
        buffer[0] = QSR_ReadChar(SER_PORT_FOR_READ);
		buffer[1] = QSR_ReadChar(SER_PORT_FOR_READ);

		if ((read_pos%P1_P2_BUFFER_SIZE)==(P1_P2_BUF_pos%P1_P2_BUFFER_SIZE))
		{
			P1blocked=1;
			P(1);
		}

		/*      */
		P1_P2_buffer[P1_P2_BUF_pos%P1_P2_BUFFER_SIZE]=*((int *)buffer);
        P1_P2_BUF_pos++;
        Print_In_Data(*((int*)buffer));
        V(2);
	}
}

/* ================================================================================ */
/* ======================        ================ */
/* ================================================================================ */

void ProcessData()
{
	int point1pos,point2pos;
	int temp;


	while (1)
	{
		P(2);

		point1pos=read_pos%(P1_P2_BUFFER_SIZE);
		point2pos=(read_pos+GAP-1)%(P1_P2_BUFFER_SIZE);

		read_pos++;

		if (P1blocked==1)
			V(1);

		temp=(int)((P1_P2_buffer[point1pos]+P1_P2_buffer[point2pos])*0.5);


		QSR_WriteChar(SER_PORT_FOR_WRITE, *((char *) &temp));
    	QSR_WriteChar(SER_PORT_FOR_WRITE, *(((char *) &temp) + 1)  );
		Print_Out_Data(temp);

	}

}

/* ================================================================================ */
/* ======================      ===================== */
/* ================================================================================ */

void Initializer()
{
	int i;
	/*      */
	QSR_InitializePort(SER_PORT_FOR_READ, B9600);
    QSR_InitializePort(SER_PORT_FOR_WRITE, B9600);

	P1_P2_BUF_pos=0;
	read_pos=0;
	P1blocked=0;

	bcls();
	PrintStr(0,1,"Input Data");
	PrintStr(40,1,"Output Data");
	bSetCursor(0,2);
	ly = ry = 2;
}

